#ifndef INDLL_H
#define INDLL_H

#include <string>
#include <qr_invoice_simple_defs.hpp>

// ----------------------------------------------------------------------------------------------------------
// PaymentPartReceipt
// ----------------------------------------------------------------------------------------------------------

// PDF
QRINVOICE_SIMPLE_API unsigned int CreatePprPdfJson(
        const char* PageSize, const char* FontFamily, const char* Language,
        bool BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText,
        const char* JsonInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprPdfJsonBase64(
        const char* PageSize, const char* FontFamily, const char* Language,
        bool BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText,
        const char* JsonInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprPdfJsonBase64In(
        const char* PageSize, const char* FontFamily, const char* Language,
        bool BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText,
        const char* JsonInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprPdfJsonBase64Out(
        const char* PageSize, const char* FontFamily, const char* Language,
        bool BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText,
        const char* JsonInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprPdfCsv(
    const char* PageSize, const char* FontFamily, const char* Language,
    bool BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText,
    const char* CsvInput,
    char *OutputBuffer, unsigned long *OutputBufferSize,
    char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprPdfCsvBase64(
    const char* PageSize, const char* FontFamily, const char* Language,
    bool BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText,
    const char* CsvInput,
    char *OutputBuffer, unsigned long *OutputBufferSize,
    char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprPdfCsvBase64In(
        const char* PageSize, const char* FontFamily, const char* Language,
        bool BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText,
        const char* CsvInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprPdfCsvBase64Out(
        const char* PageSize, const char* FontFamily, const char* Language,
        bool BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText,
        const char* CsvInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

// PNG
QRINVOICE_SIMPLE_API unsigned int CreatePprPngJson(
        const char* PageSize, const char* FontFamily, const char* Language, unsigned int Resolution,
        bool BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText,
        const char* JsonInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprPngJsonBase64(
        const char* PageSize, const char* FontFamily, const char* Language, unsigned int Resolution,
        bool BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText,
        const char* JsonInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprPngJsonBase64In(
        const char* PageSize, const char* FontFamily, const char* Language, unsigned int Resolution,
        bool BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText,
        const char* JsonInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprPngJsonBase64Out(
        const char* PageSize, const char* FontFamily, const char* Language, unsigned int Resolution,
        bool BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText,
        const char* JsonInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprPngCsv(
        const char* PageSize, const char* FontFamily, const char* Language, unsigned int Resolution,
        bool BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText,
        const char* CsvInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprPngCsvBase64(
        const char* PageSize, const char* FontFamily, const char* Language, unsigned int Resolution,
        bool BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText,
        const char* CsvInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprPngCsvBase64In(
        const char* PageSize, const char* FontFamily, const char* Language, unsigned int Resolution,
        bool BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText,
        const char* CsvInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprPngCsvBase64Out(
        const char* PageSize, const char* FontFamily, const char* Language, unsigned int Resolution,
        bool BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText,
        const char* CsvInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

// JPG
QRINVOICE_SIMPLE_API unsigned int CreatePprJpgJson(
        const char* PageSize, const char* FontFamily, const char* Language, unsigned int Resolution,
        bool BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText,
        const char* JsonInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprJpgJsonBase64(
        const char* PageSize, const char* FontFamily, const char* Language, unsigned int Resolution,
        bool BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText,
        const char* JsonInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprJpgJsonBase64In(
        const char* PageSize, const char* FontFamily, const char* Language, unsigned int Resolution,
        bool BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText,
        const char* JsonInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprJpgJsonBase64Out(
        const char* PageSize, const char* FontFamily, const char* Language, unsigned int Resolution,
        bool BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText,
        const char* JsonInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprJpgCsv(
        const char* PageSize, const char* FontFamily, const char* Language, unsigned int Resolution,
        bool BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText,
        const char* CsvInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprJpgCsvBase64(
        const char* PageSize, const char* FontFamily, const char* Language, unsigned int Resolution,
        bool BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText,
        const char* CsvInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprJpgCsvBase64In(
        const char* PageSize, const char* FontFamily, const char* Language, unsigned int Resolution,
        bool BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText,
        const char* CsvInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprJpgCsvBase64Out(
        const char* PageSize, const char* FontFamily, const char* Language, unsigned int Resolution,
        bool BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText,
        const char* CsvInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);


// PDF
QRINVOICE_SIMPLE_API unsigned int CreatePprV2PdfJson(
        const char* PageSize, const char* FontFamily, const char* Language,
        const char* BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText, bool AdditionalPrintMargin,
        const char* JsonInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprV2PdfJsonBase64(
        const char* PageSize, const char* FontFamily, const char* Language,
        const char* BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText, bool AdditionalPrintMargin,
        const char* JsonInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprV2PdfJsonBase64In(
        const char* PageSize, const char* FontFamily, const char* Language,
        const char* BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText, bool AdditionalPrintMargin,
        const char* JsonInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprV2PdfJsonBase64Out(
        const char* PageSize, const char* FontFamily, const char* Language,
        const char* BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText, bool AdditionalPrintMargin,
        const char* JsonInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprV2PdfCsv(
        const char* PageSize, const char* FontFamily, const char* Language,
        const char* BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText, bool AdditionalPrintMargin,
        const char* CsvInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprV2PdfCsvBase64(
        const char* PageSize, const char* FontFamily, const char* Language,
        const char* BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText, bool AdditionalPrintMargin,
        const char* CsvInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprV2PdfCsvBase64In(
        const char* PageSize, const char* FontFamily, const char* Language,
        const char* BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText, bool AdditionalPrintMargin,
        const char* CsvInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprV2PdfCsvBase64Out(
        const char* PageSize, const char* FontFamily, const char* Language,
        const char* BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText, bool AdditionalPrintMargin,
        const char* CsvInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

// PNG
QRINVOICE_SIMPLE_API unsigned int CreatePprV2PngJson(
        const char* PageSize, const char* FontFamily, const char* Language, unsigned int Resolution,
        const char* BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText, bool AdditionalPrintMargin,
        const char* JsonInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprV2PngJsonBase64(
        const char* PageSize, const char* FontFamily, const char* Language, unsigned int Resolution,
        const char* BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText, bool AdditionalPrintMargin,
        const char* JsonInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprV2PngJsonBase64In(
        const char* PageSize, const char* FontFamily, const char* Language, unsigned int Resolution,
        const char* BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText, bool AdditionalPrintMargin,
        const char* JsonInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprV2PngJsonBase64Out(
        const char* PageSize, const char* FontFamily, const char* Language, unsigned int Resolution,
        const char* BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText, bool AdditionalPrintMargin,
        const char* JsonInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprV2PngCsv(
        const char* PageSize, const char* FontFamily, const char* Language, unsigned int Resolution,
        const char* BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText, bool AdditionalPrintMargin,
        const char* CsvInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprV2PngCsvBase64(
        const char* PageSize, const char* FontFamily, const char* Language, unsigned int Resolution,
        const char* BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText, bool AdditionalPrintMargin,
        const char* CsvInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprV2PngCsvBase64In(
        const char* PageSize, const char* FontFamily, const char* Language, unsigned int Resolution,
        const char* BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText, bool AdditionalPrintMargin,
        const char* CsvInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprV2PngCsvBase64Out(
        const char* PageSize, const char* FontFamily, const char* Language, unsigned int Resolution,
        const char* BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText, bool AdditionalPrintMargin,
        const char* CsvInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

// JPG
QRINVOICE_SIMPLE_API unsigned int CreatePprV2JpgJson(
        const char* PageSize, const char* FontFamily, const char* Language, unsigned int Resolution,
        const char* BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText, bool AdditionalPrintMargin,
        const char* JsonInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprV2JpgJsonBase64(
        const char* PageSize, const char* FontFamily, const char* Language, unsigned int Resolution,
        const char* BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText, bool AdditionalPrintMargin,
        const char* JsonInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprV2JpgJsonBase64In(
        const char* PageSize, const char* FontFamily, const char* Language, unsigned int Resolution,
        const char* BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText, bool AdditionalPrintMargin,
        const char* JsonInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprV2JpgJsonBase64Out(
        const char* PageSize, const char* FontFamily, const char* Language, unsigned int Resolution,
        const char* BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText, bool AdditionalPrintMargin,
        const char* JsonInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprV2JpgCsv(
        const char* PageSize, const char* FontFamily, const char* Language, unsigned int Resolution,
        const char* BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText, bool AdditionalPrintMargin,
        const char* CsvInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprV2JpgCsvBase64(
        const char* PageSize, const char* FontFamily, const char* Language, unsigned int Resolution,
        const char* BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText, bool AdditionalPrintMargin,
        const char* CsvInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprV2JpgCsvBase64In(
        const char* PageSize, const char* FontFamily, const char* Language, unsigned int Resolution,
        const char* BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText, bool AdditionalPrintMargin,
        const char* CsvInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprV2JpgCsvBase64Out(
        const char* PageSize, const char* FontFamily, const char* Language, unsigned int Resolution,
        const char* BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText, bool AdditionalPrintMargin,
        const char* CsvInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

// ----------------------------------------------------------------------------------------------------------
// SwissQrCode
// ----------------------------------------------------------------------------------------------------------

// PNG
QRINVOICE_SIMPLE_API unsigned int CreateSwissQrCodePngJson(
        unsigned int DesiredQrCodeSize,
        const char* JsonInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreateSwissQrCodePngJsonBase64(
        unsigned int DesiredQrCodeSize,
        const char* JsonInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreateSwissQrCodePngJsonBase64In(
        unsigned int DesiredQrCodeSize,
        const char* JsonInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreateSwissQrCodePngJsonBase64Out(
        unsigned int DesiredQrCodeSize,
        const char* JsonInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreateSwissQrCodePngCsv(
        unsigned int DesiredQrCodeSize,
        const char* CsvInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreateSwissQrCodePngCsvBase64(
        unsigned int DesiredQrCodeSize,
        const char* CsvInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreateSwissQrCodePngCsvBase64In(
        unsigned int DesiredQrCodeSize,
        const char* CsvInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreateSwissQrCodePngCsvBase64Out(
        unsigned int DesiredQrCodeSize,
        const char* CsvInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

// JPG
QRINVOICE_SIMPLE_API unsigned int CreateSwissQrCodeJpgJson(
        unsigned int DesiredQrCodeSize,
        const char* JsonInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreateSwissQrCodeJpgJsonBase64(
        unsigned int DesiredQrCodeSize,
        const char* JsonInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreateSwissQrCodeJpgJsonBase64In(
        unsigned int DesiredQrCodeSize,
        const char* JsonInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreateSwissQrCodeJpgJsonBase64Out(
        unsigned int DesiredQrCodeSize,
        const char* JsonInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreateSwissQrCodeJpgCsv(
        unsigned int DesiredQrCodeSize,
        const char* CsvInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreateSwissQrCodeJpgCsvBase64(
        unsigned int DesiredQrCodeSize,
        const char* CsvInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreateSwissQrCodeJpgCsvBase64In(
        unsigned int DesiredQrCodeSize,
        const char* CsvInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreateSwissQrCodeJpgCsvBase64Out(
        unsigned int DesiredQrCodeSize,
        const char* CsvInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

// ----------------------------------------------------------------------------------------------------------
// SwissPaymentsCode
// ----------------------------------------------------------------------------------------------------------

QRINVOICE_SIMPLE_API unsigned int CreateSpcJson(
        const char* JsonInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreateSpcJsonBase64(
        const char* JsonInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreateSpcJsonBase64In(
        const char* JsonInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreateSpcJsonBase64Out(
        const char* JsonInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreateSpcCsv(
        const char* CsvInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreateSpcCsvBase64(
        const char* CsvInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreateSpcCsvBase64In(
        const char* CsvInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreateSpcCsvBase64Out(
        const char* CsvInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

// ----------------------------------------------------------------------------------------------------------
// Utility functions
// ----------------------------------------------------------------------------------------------------------

QRINVOICE_SIMPLE_API unsigned int ValidateJson(
        const char* JsonInput,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int ValidateJsonBase64(
        const char* JsonInputBase64,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int ValidateCsv(
        const char* CsvInput,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int ValidateCsvBase64(
        const char* CsvInputBase64,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API const bool ValidateString(const char* String);

QRINVOICE_SIMPLE_API const bool ValidateStringBase64(const char* StringBase64);

QRINVOICE_SIMPLE_API const bool ValidateCountryCode(const char* CountryCode);

// ----------------------------------------------------------------------------------------------------------
// IBAN
// ----------------------------------------------------------------------------------------------------------
QRINVOICE_SIMPLE_API const bool ValidateIBAN(const char* IBAN, bool ValidateCountryCode);

QRINVOICE_SIMPLE_API const bool ValidateQrIBAN(const char* IBAN);

QRINVOICE_SIMPLE_API unsigned int NormalizeIBAN(const char* IBAN,
        char *OutputBuffer, unsigned long *OutputBufferSize);

QRINVOICE_SIMPLE_API unsigned int FormatIBAN(const char* IBAN,
        char *OutputBuffer, unsigned long *OutputBufferSize);

// ----------------------------------------------------------------------------------------------------------
// QR-Reference
// ----------------------------------------------------------------------------------------------------------
QRINVOICE_SIMPLE_API const bool ValidateQrReference(const char* QrReference);

QRINVOICE_SIMPLE_API unsigned int NormalizeQrReference(const char* QrReference,
        char *OutputBuffer, unsigned long *OutputBufferSize);

QRINVOICE_SIMPLE_API unsigned int FormatQrReference(const char* QrReference,
                                                    char *OutputBuffer, unsigned long *OutputBufferSize);

QRINVOICE_SIMPLE_API unsigned int CreateQrReference(const char* Reference,
                                                       char *OutputBuffer, unsigned long *OutputBufferSize);

QRINVOICE_SIMPLE_API unsigned int CreateQrReferenceWithCustomerId(const char* CustomerId, const char* Reference,
                                                    char *OutputBuffer, unsigned long *OutputBufferSize);

// ----------------------------------------------------------------------------------------------------------
// Creditor Reference
// ----------------------------------------------------------------------------------------------------------
QRINVOICE_SIMPLE_API const bool ValidateCreditorReference(const char* CreditorReference);

QRINVOICE_SIMPLE_API unsigned int NormalizeCreditorReference(const char* CreditorReference,
                                                       char *OutputBuffer, unsigned long *OutputBufferSize);

QRINVOICE_SIMPLE_API unsigned int FormatCreditorReference(const char* CreditorReference,
                                                    char *OutputBuffer, unsigned long *OutputBufferSize);

QRINVOICE_SIMPLE_API unsigned int CreateCreditorReference(const char* Reference,
                                                    char *OutputBuffer, unsigned long *OutputBufferSize);

// ----------------------------------------------------------------------------------------------------------
// Fonts
// ----------------------------------------------------------------------------------------------------------
QRINVOICE_SIMPLE_API unsigned int SetFontPath(
        const char* FontPath
);

// ----------------------------------------------------------------------------------------------------------
// Logging
// ----------------------------------------------------------------------------------------------------------

QRINVOICE_SIMPLE_API unsigned int SetLogLevel(const char* LogLevel);

QRINVOICE_SIMPLE_API unsigned int SetLogFile(const char* LogFile);

QRINVOICE_SIMPLE_API unsigned int SetLazyLogFile(const char* LogFile);

#endif